/*
 *    trida DNSDomain
 *    programu Fosforuv DNS server v1.0
 *    Jan Pospisil, 2006
 *
 *    Trida reprezentuje domenove jmeno.
 *
 */


#ifndef __AF_DNSDOMAIN_CPP_
#define __AF_DNSDOMAIN_CPP_

#include <bitset.h>
#include <iostream>

#ifndef NULL
#define NULL 0
#endif


class DNSDomain {
	int count;
	string * label;

	public:
		DNSDomain();
		~DNSDomain();
		DNSDomain(char *);
		DNSDomain(string *);
		int getCount() {return count;}
		string getLabel(int);
		string toString();
		friend ostream & operator<<(ostream &, DNSDomain &);
};

/////////////////////////////////////////////////////////////////////////

DNSDomain::DNSDomain ()  {
	label = new string[1];
	label[0] = " ";
	count = 1;
}

DNSDomain::~DNSDomain ()  {
	delete [] label;
}

DNSDomain::DNSDomain (char * str)  {
	string tmp = "";
	int i = 0;
	while (str[i]) {
		int size = str[i++];
		for (int offset = i;  i-offset < size; i++)
			tmp += str[i];
		if (str[i])
			tmp += '.';
	}
	DNSDomain::DNSDomain(&tmp);
}

DNSDomain::DNSDomain (string * str)  {
	count = 1;
	for (unsigned int i = 0; i < str->length(); i++)
		if (str[0][i] == '.')
			count++;
	count++;

	label = new string[count];
	int j = 0;
	for (int i = count-1; i > 0; i--) {
		label[i] = "";
		while (str[0][j] != '.' && str[0][j] != 0)
			label[i] += str[0][j++];
		j++;
	}
	label[0] = " ";
}

string DNSDomain::getLabel(int index) {
	if (index < 0 || index > count-1)
		return NULL;
	return label[index];
}

string DNSDomain::toString() {
	string res;
	for (int i = count-1; i > 0; i--) {
		res += label[i];
		if (i > 1)
			res += ".";
	}
	return res;
}

ostream & operator<<(ostream & o , DNSDomain & d) {
	o << d.toString();
	return o;
}

#endif /*__AF_DNSDOMAIN_CPP_*/