/*
 *    hlavni programova cast
 *    programu Fosforuv DNS server v1.0
 *    Jan Pospisil, 2006
 *
 *    Hlavni cast programu - spousti samostatne vlakno pro beh vlastniho serveru
 *    a sama predstavuje uzivatelske rozhrani pro ovladani programu.
 */


#include <iostream>
#include <winsock>

#include "./Sock.cpp"
#include "./DBase.cpp"
#include "./Message.cpp"
#include "./DNSDomain.cpp"

using namespace std;

struct PARAM {
	DBase * db;
	bool quit;
};

DWORD WINAPI core(PVOID p) {
	PARAM * param = (PARAM *) p;
	DWORD res = 0;

	Message msg(param->db);

	Sock soc;
	SockData data;

	data.maxSize = 1000;
	data.data = new char[data.maxSize];

	try {
		soc.listen(53, IP_LOCALHOST);
		while (true) {
			data.size = data.maxSize;
			soc >> data;
			msg.load(&data);
			msg.makeRespons();
			soc << data;
		}
	} catch (char * msg) {
		cout << msg;
		res++;
	}

	delete [] data.data;

	return res;
}

int main() {

	cout << endl;
	cout << "      Fosforuv DNS server v1.0, 2006" << endl;
	cout << "      fosfor.software@seznam.cz" << endl;
	cout << endl;
	cout << "      (pro ukonceni stisknete 'k'," << endl;
	cout << "       pro vypis DNS databaze stisknete 'l')" << endl;
	cout << endl;

	cout << "   Nahravam databazi domen... ";
	DBase * db = new DBase();
	if (!db->loadFile("hosts.txt"))
		cout << "[FAILED]" << endl;
	else
		cout << "[OK]" << endl;
	//db->add(new string("sweb.seznam.cz"), 168430090);
	//db->add(new string("nevim.atlas.cz"), 168430091);

	cout << "   Startuji jadro..." << endl;
	HANDLE th;
	DWORD thID;
	// kuli win9x:
	thID = NULL;
	DWORD thRes;
	PARAM * param = new PARAM();
	param->db = db;
	param->quit = false;

	th = CreateThread(NULL, 0, core, (PVOID) param, 0, &thID);
	string cmd;
	while (true) {
		cout << "   ? ";
		cin >> cmd;
		if (cmd == "quit" || cmd == "exit" || cmd == "q") {
			break;
		} else if (cmd == "list") {
			cout << "   +-------------------------------------------------------------" << endl;
			cout << "   |   Vypis DNS databaze:" << endl;
			cout << db;
			cout << "   +------------------------------------------------------------" << endl;
		} else {
			cout << "   +-------------------------------------------------------------" << endl;
			cout << "   |   Napoveda:" << endl;
			cout << "   |      list            vypis DNS databaze" << endl;
			cout << "   |      quit, exit, q   konec" << endl;
			cout << "   +------------------------------------------------------------" << endl;
		}
		// kontrolovat, zda vlakno stale bezi, pokud krachlo, spustit ho znovu
	}
	
	cout << "   Ukoncuji jadro... ";
	param->quit = true;
	TerminateThread(th, 2);
	// je to tvrdy, ale nevim, jak ukoncit blokovaci funkci recvfrom, na ktere
	//    bezici vlakno travi vetsinu casu...
	
	/*
	WSACancelBlockingCall();
	if (WaitForSingleObject(th, INFINITE) != WAIT_OBJECT_0) {
        cout << "Thread join failed" << endl;
    }
	*/
	
	cout << "[OK]" << endl;
	cout << endl << "   Preji hezky den :)" << endl << endl;
	
	delete param;
	delete db;
	
	return 0;
}